<?php
class NationsController extends AppController {
	public $name = 'Nations';

	//**********************************************
	//請求テーブルの内容を、取引先と関連付けてすべて表示
	//**********************************************
	function index() {
		$this->layout = 'ajaxSuggest';
		$this->set('data', $this->Nation->find('all'));
	}
	//**********************************************
	//Ajax処理(ajaxComboBox)
	//**********************************************
	function ajax_suggest(){
		$this->layout = 'ajax';
	
		$db_settings = array(
			array('table'=>'Nation', 'field'=>'name', 'order'=>'id')
		);
		$per_page = $this->params['url']['limit'];
		$order_by = $this->params['url']['order_by'];
		$database = $this->params['url']['database'];

		//全角空白でもトリム
		$q_word   = trim(mb_convert_kana($this->params['url']['q_word'], 's'));
		$q_word   = preg_split('/[ \t\n\r]+/u', $q_word);
	
		//----------------------------------------------------
		// findのパラメータをひとつずつ作成
		//----------------------------------------------------
		//field,conditions======================
		$conditions = array();
		$full_field;
		foreach($database as $num){
			$full_field = "{$db_settings[$num]['table']}.{$db_settings[$num]['field']}";
			$field[] = $full_field;
			foreach($q_word as $q){
				$conditions['OR'][] = array("$full_field LIKE"=>"%$q%");
			}
		}
		//order======================
		$order = array();
		$count = 0;
		$order[0] = "(CASE ";
		foreach($database as $num){
			foreach($q_word as $q){
				 $order[0] .= "WHEN $full_field LIKE '$q%' THEN $count ";
				 $count++;
			}
		}
		$order[0] .= "ELSE $count END) ";
		foreach($database as $db){
			$order[] = "$full_field $order_by";
		}
		//パラメータを設定======================
		$params = array(
			'field'     =>$field,
			'conditions'=>$conditions,
			'order'     =>$order,
			'limit'     =>$per_page,
			'recursive' =>0
		);
	
		//----------------------------------------------------
		// DB問い合わせ。JSON化
		//----------------------------------------------------
		$data = $this->Nation->find('all', $params);
		$simple_data = array();
		foreach($data as $val){
			$simple_data[] = $val['Nation']['name'];
		}		
		$this->set('json', json_encode($simple_data));
	}
}
